function varargout = ALTSim(varargin)
% ALTSIM MATLAB code for ALTSim.fig
%      ALTSIM, by itself, creates a new ALTSIM or raises the existing
%      singleton*.
%
%      H = ALTSIM returns the handle to a new ALTSIM or the handle to
%      the existing singleton*.
%
%      ALTSIM('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in ALTSIM.M with the given input arguments.
%
%      ALTSIM('Property','Value',...) creates a new ALTSIM or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ALTSim_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ALTSim_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help ALTSim

% Last Modified by GUIDE v2.5 13-Nov-2017 13:24:02
% Copyright (C) 2006-2017  Anna Thorwart and Holger Schultheis


% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @ALTSim_OpeningFcn, ...
    'gui_OutputFcn',  @ALTSim_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before ALTSim is made visible.
function ALTSim_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ALTSim (see VARARGIN)

% Choose default command line output for ALTSim
handles.output = hObject;

% read in default parameter values
if exist('paramFileLocation.mat', 'file')
    load('paramFileLocation.mat','paramFile')
    handles.paramFile{1,1} = paramFile{1,1};
    handles.paramFile{1,2} = paramFile{1,2};
else
    choice = questdlg('It seems there is no configuration file present, possibly because you are running ALTSim for the first time. Please specify the path to the configuration file.', ...
        'Specify Configuration File', 'OK', 'Cancel and exit program', 'OK');
    switch choice
        case 'OK'
            [handles.paramFile{1,2}, handles.paramFile{1,1}] = uigetfile('default.conf');
            save('paramFileLocation.mat', '-struct', 'handles', 'paramFile');
        case 'Cancel and exit program'
            fclose('all');
    end
end

try
    fid=fopen(strcat(handles.paramFile{1,1}, handles.paramFile{1,2}));
    conf1=textscan(fid, '%s %n', 'CommentStyle' , '#', 'Delimiter', ':');
    set(handles.edit_noSbj, 'String', num2str(conf1{1,2}(1)));
    set(handles.edit_noBlocks, 'String', num2str(conf1{1,2}(2)));
    set(handles.checkbox_rand, 'Value', conf1{1,2}(3));
    switch  conf1{1,2}(3)
        case 0
            set(handles.edit_max,  'Visible', 'off')
            set(handles.text_max,  'Visible', 'off')
        case 1
    end
    set(handles.edit_max, 'String', num2str(conf1{1,2}(4)));
    fclose(fid);
catch
    msgbox('The file with the default values was not opened properly. Please check. You can set a new path in the Default Parameter Tab of the menu.')
end


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes ALTSim wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = ALTSim_OutputFcn(hObject, eventdata, handles) %#ok<*INUSL>
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in popupmenu_sequence.
function popupmenu_sequence_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_sequence (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_sequence contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_sequence
popup = get(hObject,'Value');
switch popup
    
    case 1
        
        set(handles.checkbox_rand,   'Visible', 'on')
        if (get(handles.checkbox_rand,'Value') == get(hObject,'Max'))
            set(handles.edit_max,  'Visible', 'on')
            set(handles.text_max,  'Visible', 'on')
        else
            set(handles.edit_max,  'Visible', 'off')
            set(handles.text_max,  'Visible', 'off')
        end
        
        set(handles.edit_noBlocks,  'Visible', 'on')
        set(handles.edit_block,  'Visible', 'on')
        set(handles.pushbutton_SaveSequence,  'Visible', 'on')
        set(handles.text_block,  'Visible', 'on')
        set(handles.text_titleSequence, 'Visible', 'on')
        set(handles.text_noBlocks,  'Visible', 'on')
        set(handles.text_saveSequences,  'Visible', 'on')
        set(handles.edit_SaveSequence,  'Visible', 'on')
        set(handles.edit_SearchSequence,  'Visible', 'off')
        set(handles.text_loadSequence,  'Visible', 'off')
        set(handles.pushbutton_SearchSequence,  'Visible', 'off')
        
        
    case 2
        
        set(handles.edit_max,  'Visible', 'off')
        set(handles.text_max,  'Visible', 'off')
        set(handles.checkbox_rand,   'Visible', 'off')
        set(handles.edit_noBlocks,  'Visible', 'off')
        set(handles.edit_block,  'Visible', 'on')
        set(handles.pushbutton_SaveSequence,  'Visible', 'off')
        set(handles.text_block,  'Visible', 'on')
        set(handles.text_titleSequence, 'Visible', 'on')
        set(handles.text_noBlocks,  'Visible', 'off')
        set(handles.text_saveSequences,  'Visible', 'off')
        set(handles.edit_SaveSequence,  'Visible', 'off')
        set(handles.edit_SearchSequence,  'Visible', 'on')
        set(handles.text_loadSequence,  'Visible', 'on')
        set(handles.pushbutton_SearchSequence,  'Visible', 'on')
        
        
end

% --- Executes during object creation, after setting all properties.
function popupmenu_sequence_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_sequence (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_noSbj_Callback(hObject, eventdata, handles)
% hObject    handle to edit_noSbj (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_noSbj as text
%        str2double(get(hObject,'String')) returns contents of edit_noSbj as a double


% --- Executes during object creation, after setting all properties.
function edit_noSbj_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_noSbj (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_noBlocks_Callback(hObject, eventdata, handles)
% hObject    handle to edit_noBlocks (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_noBlocks as text
%        str2double(get(hObject,'String')) returns contents of edit_noBlocks as a double


% --- Executes during object creation, after setting all properties.
function edit_noBlocks_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_noBlocks (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_block_Callback(hObject, eventdata, handles)
% hObject    handle to edit_block (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_block as text
%        str2double(get(hObject,'String')) returns contents of edit_block as a double


% --- Executes during object creation, after setting all properties.
function edit_block_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_block (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox_rand.
function checkbox_rand_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_rand (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if (get(hObject,'Value') == get(hObject,'Max'))
    set(handles.edit_max,  'Visible', 'on')
    set(handles.text_max,  'Visible', 'on')
else
    set(handles.edit_max,  'Visible', 'off')
    set(handles.text_max,  'Visible', 'off')
end



function edit_max_Callback(hObject, eventdata, handles)
% hObject    handle to edit_max (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_max as text
%        str2double(get(hObject,'String')) returns contents of edit_max as a double


% --- Executes during object creation, after setting all properties.
function edit_max_CreateFcn(hObject, eventdata, handles) %#ok<*DEFNU,*INUSD>
% hObject    handle to edit_max (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_SearchSequence.
function pushbutton_SearchSequence_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_SearchSequence (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[name, path] = uigetfile('*.seq', 'Get file with stimulus sequence');

if (name ~= 0)
    set(handles.edit_SearchSequence, 'String', [path, name]);
end


function edit_SaveSequence_Callback(hObject, eventdata, handles)
% hObject    handle to edit_SaveSequence (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_SaveSequence as text
%        str2double(get(hObject,'String')) returns contents of edit_SaveSequence as a double


% --- Executes during object creation, after setting all properties.
function edit_SaveSequence_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_SaveSequence (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_SaveSequence.
function pushbutton_SaveSequence_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_SaveSequence (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[name, path] = uiputfile('*.seq', 'Save stimulus sequence in ');

if (name ~= 0)
    set(handles.edit_SaveSequence, 'String', [path, name]);
end


% --- Executes on button press in pushbutton_sequence.
function pushbutton_sequence_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_sequence (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%initialize the stimuli: load stimulus matrix, compute sequence

% hObject    handle to pushbutton_sequence (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% val:          load or generate stimulus sequence
% AnzVp:        number of sequences
% matrixPath:   file with stimulus names and contingencies
% block:        definition of one training block in each cell
% savePath:     output file for generated stimulus sequence (optional)
% max:          max. number of following trials with the same contingency
% AnzBlock:     no of blocks
% randOrder:    randomize sequences?



handles.val = get(handles.popupmenu_sequence,'Value');
handles.AnzVp = str2num(get(handles.edit_noSbj, 'String')); %#ok<ST2NM>
matrixPath=get(handles.edit_MatrixPath, 'String');

blockCell= strsplit(get(handles.edit_block, 'String'),';')'; %FIXME
if any(strncmpi('"',blockCell,1))
    errordlg('Don''t start with quotation marks. That''s just for the examples.')
    return
end
handles.block=cellfun(@(x) sscanf(x, '%f'), blockCell, 'UniformOutput', false);

if handles.val && handles.AnzVp && fopen(matrixPath)>0 && ~isempty(handles.block{1,1})
    [handles.stimulusname, handles.Kont, handles.beta]= textread(matrixPath, '%s %f %f'); %#ok<DTXTRD>
    
else
    errordlg ('Numbers of sequences, the definition of training block and/or the filepath for the stimulus matrix is missing.')
    return
end

if (handles.val == 1) %generating sequences
    %check if savePath exists
    savePath = get(handles.edit_SaveSequence, 'String');
    if isempty(savePath)
        button= questdlg('Generated stimulus sequences won''t be saved. Would you like to continue?', 'Path is missing', 'Yes', 'No', 'Yes');
        if ~strcmp(button, 'Yes')
            return;
        end
        
    end
    %read in remaining parameter
    maxUS=str2double(get(handles.edit_max, 'String'));
    AnzBlock=str2num(get(handles.edit_noBlocks, 'string')); %#ok<ST2NM>
    randOrder = get(handles.checkbox_rand, 'Value');
    
    if ~isempty(handles.block{1,1}) && ~isempty(AnzBlock)
        
        
        % generating sequences
        [handles.CS,handles.US, handles.phaseInfo]= randsequ(handles.block, AnzBlock, maxUS, handles.Kont, randOrder, handles.AnzVp);
        
        % save sequence
        if ~isempty(savePath)&& ~strncmpi(savePath,'"',1) & ~isempty(handles.CS)
            dlmwrite(savePath,[handles.CS, handles.phaseInfo(:,1)])
        elseif strncmpi(savePath,'"',1)
            button= questdlg('That''s just the example file path. Nothing will be saved. Would you like to continue?', 'Path is missing', 'Yes', 'No', 'Yes');
            if ~strcmp(button, 'Yes')
                return;
            end
        end
        
        
    else
        errordlg ('Defintion of training block and/or number of blocks is missing')
        return
    end
    
    
elseif (handles.val == 2) %loading sequence file
    sequencePath= get(handles.edit_SearchSequence, 'String');
    if sequencePath
        try
            seqMatrix=dlmread(sequencePath);
        catch ME
            errordlg(ME.message)
            return
        end
        %Do some initial testing
        if max(max(seqMatrix))>size(handles.Kont,1)
            errordlg(['There are trials specifed in sequences that are not defined in the trial matrix.'])
            handles.CS=[];
            handles.US=[];
            handles.phaseInfo=[];
            return
        end
        
        if handles.AnzVp+1==size(seqMatrix,2) % seqMatrix should have a column for each sequence and one for the phaseInfo
            handles.CS=seqMatrix(:,1:handles.AnzVp); % Read in sequences
            handles.phaseInfo=seqMatrix(:,end); % read in phaseInfo in last column
            handles.US=handles.Kont(handles.CS);
        elseif handles.AnzVp ==size(seqMatrix,2)% is is old file format wihtout phaseInfo?
            button=questdlg({['The indicated number of sequences doesn''t match ' ...
                'the format of the sequence file.' ...
                'The sequence file has ' num2str(size(seqMatrix,2)) ' columns, '...
                'which should equal ' num2str(size(seqMatrix,2)-1) ' sequences.' ]; ...
                ['If the sequences were generated with ALTSim 3.x, ' ...
                'where no information on the phase was saved, you can click "Old file" and the simulator will read all columns '...
                'as sequences and assume that there is only one phase. Otherwise, click "Cancel".']}, ...
                'Sequences', 'Old file', 'Cancel', 'Old file');
            if strcmp(button, 'Old file')
                handles.CS=seqMatrix; % Read whole matrix as sequences
                handles.phaseInfo=ones(size(seqMatrix,1),1); % generate some phaseInfo, so the code is working
                handles.AnzVp=size(handles.CS,2); % update no of sequences
                handles.US=handles.Kont(handles.CS);
                set(handles.edit_noSbj, 'String', num2str(handles.AnzVp));
            else                
                return
            end
        else
         errordlg (['The indicated number of sequences is different than the number of sequences provided in the sequence file. '...
             'The sequence file has ' num2str(size(seqMatrix,2)) ' columns, ' ...
                'which should equal ' num2str(size(seqMatrix,2)-1) ' sequences.' ])
            return
        end
        
    else
        errordlg ('Path for sequence file is missing')
        return
    end
    
    % Do some more testing:
     
    if max(cellfun(@max, handles.block))>size(handles.Kont,1)
        errordlg(['There are trials specifed in "trials trained in each block" that are not defined in the trial matrix.']) %#ok<*NBRAK>
        handles.CS=[];
        handles.US=[];
        handles.phaseInfo=[];
        return
    end
    
    
    if max(handles.phaseInfo) ~= size(handles.block,1);
        errordlg('Different numbers of phases are specified in sequences and in "trials trained in each block" .')
        handles.CS=[];
        handles.US=[];
        handles.phaseInfo=[];
        return
    end
    
end

guidata(hObject, handles);
if ~isempty(handles.CS) && ~isempty(handles.US)
    helpdlg ('Stimuli initialized!')
    
end


% --- Executes on button press in pushbutton_simulate.
function pushbutton_simulate_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_simulate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% The general parameters passed by paramsGen are
% Stimulusname: string name of all CS
% Testname:     "
% Kont:         US paired with CS
% KontTest:     "
% beta:         beta of USs
% AnzVp:        number of sequences
% CS:           CS-sequence: noTrial*AnzVp-matrix
% US:           US-sequence: noTrial*AnzVp-matrix
% block:        CS that occur during training , specified by their line number in Stimulusname
% code:         stimuluscode of all CS: a line defines the occurrence of each single stimulus in a CS (without unique cue or similar)
% testcode:     "
% paramfile:    Path and name of paramter file

%NOTE: im Moment werden keine eigenen Testreize definiert, sondern alle in
%den Reizmatrix definierten Reize getestet.



% parameters already used in pushbutton_sequence_callback
if all(isfield(handles, {'stimulusname', 'Kont', 'beta','AnzVp', 'CS', 'US', 'block'})) && ~isempty(handles.CS)
    paramsGen.Stimulusname=handles.stimulusname;
    paramsGen.Testname=handles.stimulusname;
    paramsGen.Kont=handles.Kont;
    paramsGen.KontTest=handles.Kont;
    paramsGen.beta=handles.beta;
    paramsGen.AnzVp=handles.AnzVp;
    paramsGen.CS= handles.CS;
    paramsGen.phaseInfo=handles.phaseInfo;
    paramsGen.US= handles.US;
    paramsGen.block= handles.block;
    paramsGen.paramFile=handles.paramFile;
else
    errordlg ('Please initialize stimuli first.')
    return
end



%remaining parameter
codePath=get(handles.edit_CodePath, 'String');
theory = get(handles.popupmenu_theory,'value');

if  ~isempty(codePath)
    try
        paramsGen.code=dlmread(codePath);
        paramsGen.testcode = dlmread(codePath);
        
    catch ME
        errordlg(ME.message)
        return
    end
    
    
    switch theory
        case 1
            Pearce(paramsGen);
        case 2
            RescorlaWagner(paramsGen);
        case 3
            repElements(paramsGen);
        case 4
            Harris(paramsGen);
        case 5
            InElements(paramsGen);
    end;
else
    errordlg ('Filepath for stimulus code is missing')
    return
end


% --- Executes during object creation, after setting all properties.
function edit_MatrixPath_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_MatrixPath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_SearchMatrix.
function pushbutton_SearchMatrix_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_SearchMatrix (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[name, path] = uigetfile('*.mtx;*.txt', 'Get file with trial matrix');

if (name ~= 0)
    set(handles.edit_MatrixPath, 'String', [path, name]);
end

% --- Executes on selection change in popupmenu_theory.
function popupmenu_theory_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_theory (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_theory contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_theory


% --- Executes during object creation, after setting all properties.
function popupmenu_theory_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_theory (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_MatrixPath_Callback(hObject, eventdata, handles)
% hObject    handle to edit_MatrixPath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_MatrixPath as text
%        str2double(get(hObject,'String')) returns contents of edit_MatrixPath as a double


function edit_CodePath_Callback(hObject, eventdata, handles)
% hObject    handle to edit_CodePath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_CodePath as text
%        str2double(get(hObject,'String')) returns contents of edit_CodePath as a double


% --- Executes during object creation, after setting all properties.
function edit_CodePath_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_CodePath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_SearchCode.
function pushbutton_SearchCode_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_SearchCode (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[name, path] = uigetfile('*.cde;*.txt', 'Get file with stimulus code');

if (name ~= 0)
    set(handles.edit_CodePath, 'String', [path, name]);
end

% --- Executes on button press in pushbutton_ViewStimuli.
function pushbutton_ViewStimuli_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_ViewStimuli (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
matrixPath=get(handles.edit_MatrixPath, 'string');
codePath=get(handles.edit_CodePath, 'string');
if ~isempty(matrixPath) && ~isempty(codePath)
    h=stimulusViewer([1,2], matrixPath, codePath);
    stimulusViewer('stimulusViewer_UpdateFcn',h,0,guidata(h))
else
    errordlg('Filepath for trial matrix and/or stimulus code is missing.')
    return
end

% --------------------------------------------------------------------
function info_Callback(hObject, eventdata, handles)
% hObject    handle to info (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Homepage_Callback(hObject, eventdata, handles)
% hObject    handle to Homepage (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
try
    web('https://www.uni-marburg.de/fb04/team-lachnit/mitarbeiter/thorwart/simulators', '-browser')
catch
    errordlg('That didn''t work. Do you have internet access?')
end


% --------------------------------------------------------------------
function ReleaseNotes_Callback(hObject, eventdata, handles)
% hObject    handle to ReleaseNotes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if ismac
    % Code to run on Mac plaform
   web('ReleaseNotes.pdf', '-browser')
elseif isunix
    % Code to run on Linux plaform
    web('ReleaseNotes.pdf', '-browser')
elseif ispc
    % Code to run on Windows platform
    winopen('ReleaseNotes.pdf')    
else
    disp('Platform not supported')
end

% --------------------------------------------------------------------
function About_Callback(hObject, eventdata, handles)
% hObject    handle to About (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
msgbox({'ATLSim 4.0; copyright Dr Anna Thorwart et al., Philipps-Universitï¿½t Marburg, anna.thorwart@staff.uni-marburg.de; licensed under GNU and BSD.';'';
'The function TextEdit is based on Matlab FEX contribution 63411 "TextEdit with Java", copyright (c) 2017, Emmanuel Farhi.'})


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
delete(hObject);
close all
clear all %#ok<CLALL>


% --- Executes during object creation, after setting all properties.
function pushbutton_SearchSequence_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pushbutton_SearchSequence (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function edit_SearchSequence_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_SearchSequence (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --------------------------------------------------------------------
function DefaultParamMenu_Callback(hObject, eventdata, handles)
% hObject    handle to DefaultParamMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function ParamFile_Callback(hObject, eventdata, handles)
% hObject    handle to ParamFile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

try TextEdit(fullfile(handles.paramFile{1,1}, handles.paramFile{1,2}));
    uiwait;
catch
    
    errordlg('Sorry, opening the file didn''t work.', 'Compability issue')
end


% update in default parameter values
try
    fid=fopen(fullfile(handles.paramFile{1,1}, handles.paramFile{1,2}));
    conf1=textscan(fid, '%s %n', 'CommentStyle' , '#', 'Delimiter', ':');
    
    %GENERAL
    set(handles.edit_noSbj, 'String', num2str(conf1{1,2}(1)));
    set(handles.edit_noBlocks, 'String', num2str(conf1{1,2}(2)));
    set(handles.checkbox_rand, 'Value', conf1{1,2}(3));
    switch  conf1{1,2}(3)
        case 0
            set(handles.edit_max,  'Visible', 'off')
            set(handles.text_max,  'Visible', 'off')
        case 1
            set(handles.edit_max,  'Visible', 'on')
            set(handles.text_max,  'Visible', 'on')
    end
    set(handles.edit_max, 'String', num2str(conf1{1,2}(4)));
    
    
    
    fclose(fid);
    guidata(hObject, handles);
    
catch
    msgbox('The file with the default values was not opened properly. Please check.  You can set a new path in the Default Parameter Tab of the menu.')
end


% --------------------------------------------------------------------
function ParamFileChange_Callback(hObject, eventdata, handles)
% hObject    handle to ParamFileChange (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[handles.paramFile{1,2}, handles.paramFile{1,1}] = uigetfile('default.conf');
save('paramFileLocation.mat', '-struct', 'handles', 'paramFile');
guidata(hObject, handles);



%-------------------------------------------------------------------------------
%     This file is part of ALTSim.
%
%     ALTSim is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
%
%     ALTSim is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
%
%     You should have received a copy of the GNU General Public License
%     along with ALTSim.  If not, see <http://www.gnu.org/licenses/>.
