function style=linestyle(noLines)
%creates noLines combinations of marker, color and linestyle 

% Copyright (C) 2006-2017  Anna Thorwart and Holger Schultheis
% with thanks to someone from the Math Forum Discussion Group

markerStyle={'o','*','s', 'x', 'v', 'o','*','s', 'x', 'v', 'o','*','s', 'x', 'v'};
lineColor = {'g', 'r', 'b', 'c', 'm', 'y', 'k','g', 'r', 'b', 'c', 'm', 'y', 'k'};
lineStyle = {'-','-.', '--', '-', '-.', '--', '-','-.', '--', '-', '-.', '--', '-','-.', '--', '-', '-.', '--'};

marker_idx= 1;
color_idx = 1;
style_idx = 1;

for i=1:noLines
    if color_idx > length(lineColor)
        color_idx = 1; % reset the color index.
    end
    if style_idx > length(lineStyle)
        style_idx = 1; % reset the style index.
    end
    if marker_idx > length(markerStyle)
        marker_idx = 1;
    end
    style {i}= [lineColor{color_idx}, lineStyle{style_idx}, markerStyle{marker_idx}];
    color_idx = color_idx + 1;
    style_idx = style_idx + 1;
    marker_idx = marker_idx + 1;
end

%-------------------------------------------------------------------------------
%     This file is part of ALTSim.
% 
%     ALTSim is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     ALTSim is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with ALTSim.  If not, see <http://www.gnu.org/licenses/>.