function plotOutputActivation(data, phases, figstring, titlestring, legendstring)
%subfuntion that plots output activation 

% Copyright (C) 2006-2017  Anna Thorwart and Holger Schultheis

figure ('NumberTitle', 'off','Name', figstring);
style=linestyle(size(data,2));
data(data== -32767) = NaN;
noPhases=max(phases);
for pp=1:noPhases
    hS(pp)=subplot(1,noPhases,pp);
    noTrials=sum(phases==pp);
    startTrial=find(phases==pp,1);
    for i = 1: size(data,2)
        %Zeiche Grafik mit Legende und Achsenbeschriftung
        plot(data(startTrial:startTrial+noTrials-1,i),style{i});
        hold on;
    end
    xlabel(['Phase ' num2str(pp) ': Trial No.']), ylabel('Activation of US representation by CSs');
   hL=legend(legendstring, 'Location', 'NorthEastOutside');
   title(hS(round(noPhases/2)),[titlestring], 'FontWeight', 'normal', 'FontSize', 8)
end


title(hS(round(noPhases/2)),[titlestring], 'FontWeight', 'normal', 'FontSize', 8)
%-------------------------------------------------------------------------------
%     This file is part of ALTSim.
% 
%     ALTSim is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     ALTSim is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with ALTSim.  If not, see <http://www.gnu.org/licenses/>.