function [amatrix]=sorttrials(aktivmatrix,inp,phaseInfo, trialtype)
%sortiert Aktivierungsmatrix nach praesentierten Reizen
%NOTE: die amtrix ist zu lang (naemlich length(aktivmatrix)). Deswegen ist die x-Achse im plot zu
%lang.
% Copyright (C) 2006-2017  Anna Thorwart and Holger Schultheis

if size(aktivmatrix,1)~=1
    error('Erstes Input-Argument muß ein Zeilenvektor sein')
end
trialartzaehler=zeros(trialtype,1);

% split training in phases :
noPhases=max(phaseInfo);
% [lengthPhases, ~] = cellfun(@size, CSPhase);
% phaseInfo=zeros(sum(lengthPhases),1);

for pp=1:noPhases
    lengthPhases(pp)=sum(phaseInfo==pp);
    amatrixPhase{pp,1}=NaN(lengthPhases(pp),trialtype);
    trialartzaehler=zeros(trialtype,1);

    trialmatrix=[];
    startPhase=sum(lengthPhases(1:pp-1))+1;
    endPhase=startPhase+lengthPhases(pp)-1;
    
    for k=startPhase:endPhase
        for ii=1:trialtype
            if ii == inp(k,:)
                trialartzaehler(ii)=trialartzaehler(ii)+1;
                amatrixPhase{pp,1}(trialartzaehler(ii),ii)=aktivmatrix(k);
                trialmatrix(trialartzaehler(ii),ii)=sum(trialartzaehler);
            end
        end
    end
%     phaseInfo(startPhase:endPhase,1)=pp;
end

amatrix=cell2mat(amatrixPhase);

% amatrix=amatrix(~all(isnan(amatrix(:,1:trialtype)),2),:);

if (trialartzaehler)==zeros(size(trialartzaehler))
    error('keine Übereinstimmung zwischen Zeilen der Inputmatrix und darzustellenden Reizen gefunden')
end

%-------------------------------------------------------------------------------
%     This file is part of ALTSim.
% 
%     ALTSim is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     ALTSim is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with ALTSim.  If not, see <http://www.gnu.org/licenses/>.

