function varargout = stimulusViewer(varargin)
% STIMULUSVIEWER MATLAB code for stimulusViewer.fig
%      STIMULUSVIEWER, by itself, creates a new STIMULUSVIEWER or raises the existing
%      singleton*.
%
%      H = STIMULUSVIEWER returns the handle to a new STIMULUSVIEWER or the handle to
%      the existing singleton*.
%
%      STIMULUSVIEWER('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in STIMULUSVIEWER.M with the given input arguments.
%
%      STIMULUSVIEWER('Property','Value',...) creates a new STIMULUSVIEWER or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before stimulusViewer_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to stimulusViewer_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help stimulusViewer

% Last Modified by GUIDE v2.5 16-Jun-2017 11:41:42
% Copyright (C) 2006-2017  Anna Thorwart and Holger Schultheis

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @stimulusViewer_OpeningFcn, ...
    'gui_OutputFcn',  @stimulusViewer_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before stimulusViewer is made visible.
function stimulusViewer_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to stimulusViewer (see VARARGIN)

% Choose default command line output for stimulusViewer
handles.output = hObject;
handles.matrixPath = varargin{2}; %FIXME: wenn das erste Argument ein string ist, wird Zeile 36 ausgefuehrt und dann gibt es eine Fehlermeldung
handles.codePath = varargin{3};


% Update handles structure
guidata(hObject, handles);



% UIWAIT makes stimulusViewer wait for user response (see UIRESUME)
% uiwait(handles.figure1);

function stimulusViewer_UpdateFcn(hObject, eventdata, handles)

if ~isempty(handles.matrixPath)
    fid=fopen(handles.matrixPath);
    if fid>0
        handles.matrix=textscan(fid, '%s %f %f');
        if isnan(handles.matrix{3}) %if there are no betas defined, all betas =1
            handles.matrix{3}= ones(size(handles.matrix{2}));
            betaerror=errordlg('No betas are defined in the trial matrix file. All betas are set to one.');
            waitfor(betaerror)
        end
        handles.matrix=[handles.matrix{1} num2cell(handles.matrix{2}) num2cell(handles.matrix{3})];
        fclose(fid);
        set(handles.uitable_matrix, 'Data',handles.matrix);
%         C = strsplit(handles.matrixPath,'\');      %TODO: delete this 
%         set(handles.uipanel_matrix, 'Title', C{end});
    else
        errordlg('Something is wrong with the trial matrix filepath.')
        delete(handles.figure1);
        return
    end
else delete(handles.uitable_matrix)
end

if ~isempty(handles.codePath) %
    % if file is completely empty,dlmread cannot read it.
    s=dir(handles.codePath);
    if s.bytes==0
        handles.code=[];
        set(handles.uitable_code, 'Data',handles.code);
    else
        try
            handles.code=dlmread(handles.codePath);
            set(handles.uitable_code, 'Data',handles.code);
            %         C = strsplit(handles.codePath,'\'); %TODO: delete this
            %         set(handles.uipanel_code, 'Title', C{end});
        catch ME
            errordlg('Something is wrong with the stimulus code filepath.')
            delete(handles.figure1);
            return
        end
    end
end

if size(handles.code,1)~=size(handles.matrix,1)
    warndlg('As each row represents one trial type,the trial matrix and in the stimulus code must have equal number of rows.')
end

guidata(hObject, handles);

% --- Outputs from this function are returned to the command line.
function varargout = stimulusViewer_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton_save.
function pushbutton_save_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%save changes in stimulus matrix
if  ~isempty(handles.matrixPath)
    fid = fopen(handles.matrixPath, 'w');
    matrix=handles.matrix;
    for i=1:size(matrix,1), % for each row
        fprintf(fid, '%s %1.5f %1.3f\n', matrix{i,:});
    end
    fclose(fid);
else
    handles.matrix=[];
end

%save changes in stimulus code
dlmwrite(handles.codePath, handles.code, '\t');

delete(handles.figure1);

% --- Executes on button press in pushbutton_cancel.
function pushbutton_cancel_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_cancel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
delete(handles.figure1);



% --- Executes when entered data in editable cell(s) in uitable_code.
function uitable_code_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to uitable_code (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with handles and user data (see GUIDATA)

handles.code=get(hObject,'Data');
guidata(hObject, handles);

% --- Executes when entered data in editable cell(s) in uitable_matrix.
function uitable_matrix_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to uitable_matrix (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with handles and user data (see GUIDATA)

handles.matrix=get(hObject,'Data');
guidata(hObject, handles);


function uitable_matrix_KeyPressFcn(hObject, eventdata, handles)


% --- Executes on button press in pushbutton_OpenMatrix.
function pushbutton_OpenMatrix_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_OpenMatrix (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

TextEdit(handles.matrixPath)





% --- Executes on button press in pushbutton_ReloadMatrix.
function pushbutton_ReloadMatrix_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_ReloadMatrix (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
stimulusViewer_UpdateFcn(hObject, eventdata, handles)


% --- Executes on button press in pushbutton_OpenCode.
function pushbutton_OpenCode_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_OpenCode (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

TextEdit(handles.codePath)



% --- Executes on button press in pushbutton_ReloadCode.
function pushbutton_ReloadCode_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_ReloadCode (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
stimulusViewer_UpdateFcn(hObject, eventdata, handles)


%-------------------------------------------------------------------------------
%     This file is part of ALTSim.
% 
%     ALTSim is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     ALTSim is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with ALTSim.  If not, see <http://www.gnu.org/licenses/>.
